// def accessKey = "access_key";
// def secredKey = "secret_access_key";
// def bucket = "my_bucket";
// def key = "DemoCluster/node1";
// def expiry = <seconds since epoch when url expires>

// see http://www.jgroups.org/javadoc/org/jgroups/protocols/S3_PING.html
// you need jgroups.jar v2.10.1+ in classpath

@Grab(group='org.jgroups', module='jgroups', version='3.1.0.Final')
import org.jgroups.protocols.S3_PING;
import java.util.GregorianCalendar;

def accessKey = "your access key";
def secredKey = "your secret key";
def bucket = "your bucket;
def key = "your path within bucket";
// long expiry = 1483221600; // 2017-01-01
def cal = GregorianCalendar.getInstance();
cal.add(GregorianCalendar.YEAR, 5);
long expiry = cal.getTimeInMillis() / 1000; // 5 years from now as seconds after epoch

String putUrl = S3_PING.generatePreSignedUrl(accessKey, secredKey, "put",
                                             bucket, key, expiry);
 
String deleteUrl = S3_PING.generatePreSignedUrl(accessKey, secredKey, "delete",
                                                 bucket, key, expiry);

String getUrl = S3_PING.generatePreSignedUrl(accessKey, secredKey, "get",
                                             bucket, key, expiry);

println("PUT Url: $putUrl");
println("DELETE Url: $deleteUrl");
println("GET Url: $getUrl");
